//
//
//
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>

#include "xvm.h"
#include "xvmconfig.h"
#include "xvmsupport.h"

#define XVM_VER_TINYCON "0.1.4"

int conflag=0;
int fdsin;
Xvm *xxx;

int main();
int MainLoop();
int PrintRegs();
int PrintComms();
char* GetAbout();
char* GetVersion();
int ReadInput();

int 
main(){
	xxx=new Xvm;
	printf(GetAbout());
	printf(xxx->GetAbout());
	printf(GetAboutSupport());
	MainLoop();
	delete(xxx);
};

int 
ReadInput(){
	//char temp;
	char sbuf[MAX_XVM_COMMENT_LEN];
	char* stext;
	stext=sbuf;
	char* stok[3];
	if(conflag==0){
		printf("CONSOLE : ");
		conflag=1;
	};
	if(1){
		gets(stext);
		conflag=0;
		stok[0]=strtok(stext," ");
		stok[1]=strtok(NULL," ");
		stok[2]=strtok(NULL," ");
		switch(*stok[0]){
			case 'i':
				xxx->InitProg(1);
				return 0;
				break;
			case 's':
				xxx->StepProg();
				printf("Current command : %d\n",
					xxx->GetCurCommNo());
				printf("Statement       : ");
				printf(xxx->GetComm(xxx->GetCurCommNo()));
				printf("\n");
				if(xxx->GetProgStatus()==XVM_ERRORSTOP){
					printf("Stoped on ERROR.\nPrevious command : %d\n",xxx->GetPrevCommNo());
					printf("Current command : %d\nStatement : %s\n",
						xxx->GetCurCommNo(),xxx->GetComm(xxx->GetCurCommNo()));
					printf("Error type : %d\nError message : %s\n",xxx->GetErrorType(),
						xxx->GetError());
				};
				return 0;
				break;
			case 'e':
				xxx->InitProg(1);
				printf("Executing...\n");
				while(xxx->GetProgStatus()==XVM_EXECUTING){
					xxx->StepProg();
				};
				if(xxx->GetProgStatus()==XVM_ERRORSTOP){
					printf("Stoped on ERROR.\nPrevious command : %d\n",xxx->GetPrevCommNo());
					printf("Current command : %d\nStatement : %s\n",
						xxx->GetCurCommNo(),xxx->GetComm(xxx->GetCurCommNo()));
					printf("Error type : %d\nError message : %s\n",xxx->GetErrorType(),
						xxx->GetError());
				}
				else{
         				printf("Stoped at \t\t%d\nPrevious statement \t%d\n",
						xxx->GetCurCommNo(),xxx->GetPrevCommNo());
				};
				return 0;
				break;
			case 'b':
				return 0;
				break;
			case 'q':
				printf("\nExit.\n\n");
				return 1;
				break;
			case 'l':
				if(stok[1]==NULL) stok[1]=" ";
				switch(*stok[1]){
					case 'r':
						PrintRegs();
						break;
					case 'c':
						PrintComms();
						break;
					default:
						printf("Must be: (r)egs | (c)omms\n");
						break;
				};
				return 0;
				break;
			case 'r':
				if(stok[1]==NULL){
					printf("Must be: REG_NO [VAL] (if VAL==`` then 0)\n");
				}
				else{
					if(stok[2]==NULL) stok[2]="";
					xxx->SetReg(atoi(stok[1]),stok[2]);
					xxx->SetDReg(atoi(stok[1]),atoi(stok[2]));
				};
				return 0;
				break;
			case 'c':
				if(stok[1]==NULL){
					printf("Must be: COMM_NO [STAT]\n");
				}
				else{
					if(stok[2]==NULL) stok[2]="";
					xxx->SetComm(atoi(stok[1]),stok[2]);
				};
				return 0;
				break;
			case 'd':
				if(stok[1]==NULL){
					printf("Must be d (load :-) FILENAME\n");
				}
				else{
					if(PrepareLoad(stok[1],0,(class Xvm *)xxx)!=-1){
						LoadXVMStatus();
						printf("Load OK.\n");
					}
					else{
						printf("Can`t load.\n");
					};
				};
				return 0;
				break;
			case 'a':
				return 0;
				break;
			case 'w':
				if(stok[1]==NULL){
					printf("Must be (w)rite FILENAME\n");
				}
				else{
					if(PrepareSave(stok[1],0,(class Xvm *)xxx)!=-1){
						SaveXVMStatus();
						printf("Save OK.\n");
					}
					else{
						printf("Can`t write.\n");
					};
				};
				return 0;
				break;
			default:
				printf("Must be:\n");
				printf("\t(i)nit\n");
				printf("\t(s)tep\n");
				printf("\t(e)xecute\n");
				printf("\t(l)ist (r)egisters\n");
				printf("\t(l)ist (c)ommands\n");
				printf("\t(r)egister REG_NO [VAL] (if VAL==`` then 0)\n");
				printf("\t(c)ommand COMM_NO [STAT]\n");
				printf("\t(d) (it`s load :-) FILENAME\n");
				printf("\t(w)rite FILENAME\n");
				printf("\t(q)uit\n");
				return 0;
				break;
		};				
	}
	else{
		return 0;
	};
};

int 
MainLoop(){
	int CStatus=0;
	while(CStatus!=1){
		CStatus=ReadInput();		
	};
	return 1;
};

int 
PrintRegs(){
	int temp;
	printf("Registers:\n--------------------------\n REG\tVAL\n--------------------------\n");
	for(temp=1;temp<11;temp++){
		printf(" %d\t",temp);
		printf(xxx->GetReg(temp));
		printf("\n");
	};
	return 1;
};

int 
PrintComms(){
	int temp;
	printf("Commands:\n--------------------------\n COMM\tSTAT\n--------------------------\n");
	for(temp=1;temp<21;temp++){
		printf(" %d\t",temp);
		printf(xxx->GetComm(temp));
		printf("\n");
	};
	return 1;
};

char* 
GetAbout(){
	char* ts;
	ts=new char[MAX_XVM_COMMENT_LEN];
	strcpy(ts,"XVM TinyCon, version: ");
	strcat(ts,GetVersion());
	strcat(ts," . Copyright(c) 1998 Dmitry Morozhnikov.\n");
	return ts;
	delete ts;
};

char* 
GetVersion(){
	return XVM_VER_TINYCON;
};

